package it.enea.xlab.GECORegistration.data;

import java.util.HashMap;
import java.util.Map;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;

import lombok.Getter;

@JsonInclude(JsonInclude.Include.NON_NULL)
@Getter
public class InputParameters {

	/**
	 * 
	 */
	private Integer communityid;
	private Integer queryid;
	private Integer flowid;
		
	@JsonIgnore
	private String token;
		
	@JsonIgnore
	private String language;
	
	@JsonIgnore
	private Integer userid;
		
	@JsonIgnore
	private HashMap<String, String> parameters = new HashMap<String, String>(); 
	
	
	@Override
	public String toString() {
		String toString = "{";
		
//		toString = toString + "\n\ttoken:" + token;
//		toString = toString + "\n\tlanguage:" + language;
//		toString = toString + "\n\tcommunityid:" + communityid;
//		toString = toString + "\n\tqueryid:" + queryid;
//		toString = toString + "\n\tflowid:" + flowid;
//		toString = toString + "\n\tuserid:" + userid;
		
		for (String key : parameters.keySet()) {
			toString = toString + "\n\t" + key + ":" + parameters.get(key) +",";
		}
		
		return toString.substring(0, toString.length()-1) + "\n}";
	}
	

	public void setToken(String token) {
		this.parameters.put("token", token);
		this.token = token;
	}
	public void setCommunityid(Integer communityid) {
		this.parameters.put("communityid", communityid.toString());
		this.communityid = communityid;
	}
	public void setQueryid(Integer queryid) {
		this.parameters.put("queryid", queryid.toString());
		this.queryid = queryid;
	}

	public void setParameters(Map<String, Object> otherParameters) {
		for (String key : otherParameters.keySet()) { 
			this.parameters.put(key.trim(), otherParameters.get(key).toString());
		}
		
	}
	public void setFlowid(Integer flowid) {
		this.parameters.put("flowid", flowid.toString());
		this.flowid = flowid;
	}

	public void setLanguage(String language) {
		this.parameters.put("language", language);
		this.language = language;
	}

	public void setUserid(Integer userid) {
		this.parameters.put("userid", userid.toString());
		this.userid = userid;
	}
	
}
